   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.8 - 03 Dec 2008
   3                     ; Optimizer V4.2.8 - 03 Dec 2008
1688                     ; 22 @far @interrupt void AWU_Interrupt (void) 
1688                     ; 23 { AWU_CSR;
1689                     .aligned:	section	.text
1690  0000               f_AWU_Interrupt:
1696  0000 c650f0        	ld	a,_AWU_CSR
1697                     ; 25   PB_ODR = ~PB_ODR;
1699  0003 72535005      	cpl	_PB_ODR
1700                     ; 28 	PC_ODR = ~PC_ODR; //  PC_ODR ^= 0x78;
1702  0007 7253500a      	cpl	_PC_ODR
1703                     ; 29 	PA_ODR = ~PA_ODR; //  PA_ODR ^= 0x3C;
1705  000b 72535000      	cpl	_PA_ODR
1706                     ; 30   PD_ODR = ~PD_ODR;
1708  000f 7253500f      	cpl	_PD_ODR
1709                     ; 32 	return;
1712  0013 80            	iret	
1737                     ; 37 @far @interrupt void Button1_Interrupt (void)
1737                     ; 38 { 
1738                     	switch	.text
1739  0000               f_Button1_Interrupt:
1741  0000 3b0002        	push	c_x+2
1742  0003 be00          	ldw	x,c_x
1743  0005 89            	pushw	x
1744  0006 3b0002        	push	c_y+2
1745  0009 be00          	ldw	x,c_y
1746  000b 89            	pushw	x
1749                     ; 41   CLK_CKDIVR = 0x03; //HSI as clock source, max divider
1751  000c 350350c0      	mov	_CLK_CKDIVR,#3
1752                     ; 43   Left_Button_RAM();
1754  0010 cd0000        	call	_Left_Button_RAM
1756                     ; 45   CLK_CKDIVR = 0x00; //HSI as clock source, no divider
1758  0013 725f50c0      	clr	_CLK_CKDIVR
1759                     ; 47   EXTI_SR1 &= 0x40; //clear interrupt flag 
1761  0017 c650a3        	ld	a,_EXTI_SR1
1762  001a a440          	and	a,#64
1763  001c c750a3        	ld	_EXTI_SR1,a
1764                     ; 48 	return;
1767  001f 85            	popw	x
1768  0020 bf00          	ldw	c_y,x
1769  0022 320002        	pop	c_y+2
1770  0025 85            	popw	x
1771  0026 bf00          	ldw	c_x,x
1772  0028 320002        	pop	c_x+2
1773  002b 80            	iret	
1835                     ; 51 @far @interrupt void Button2_Interrupt (void)
1835                     ; 52 { u8 c;
1836                     	switch	.text
1837  002c               f_Button2_Interrupt:
1839       00000004      OFST:	set	4
1840  002c 5204          	subw	sp,#4
1843                     ; 53   PC_CR1 &= ~0x04; //disable pull-up
1845  002e 7215500d      	bres	_PC_CR1,#2
1846                     ; 54 	PC_CR2 = 0x00;  //disable interrupt for button PC2
1848  0032 725f500e      	clr	_PC_CR2
1849                     ; 56 	Flags |= 0x04;
1851  0036 72140000      	bset	_Flags,#2
1852                     ; 61   LCD_INDEX[2]++;
1854  003a 3c02          	inc	_LCD_INDEX+2
1855                     ; 62 	if (LCD_INDEX[2] > 9)
1857  003c b602          	ld	a,_LCD_INDEX+2
1858  003e a10a          	cp	a,#10
1859  0040 2516          	jrult	L7021
1860                     ; 64 		LCD_INDEX[2] = 0;
1862  0042 3f02          	clr	_LCD_INDEX+2
1863                     ; 65   	LCD_INDEX[1]++;
1865  0044 3c01          	inc	_LCD_INDEX+1
1866                     ; 66 	  if (LCD_INDEX[1] > 9)
1868  0046 b601          	ld	a,_LCD_INDEX+1
1869  0048 a10a          	cp	a,#10
1870  004a 250c          	jrult	L7021
1871                     ; 68 			LCD_INDEX[1] = 0;
1873  004c 3f01          	clr	_LCD_INDEX+1
1874                     ; 69 			LCD_INDEX[0]++;
1876  004e 3c00          	inc	_LCD_INDEX
1877                     ; 70 			if (LCD_INDEX[0] > 9)
1879  0050 b600          	ld	a,_LCD_INDEX
1880  0052 a10a          	cp	a,#10
1881  0054 2502          	jrult	L7021
1882                     ; 72 				LCD_INDEX[0] = 0;
1884  0056 3f00          	clr	_LCD_INDEX
1885  0058               L7021:
1886                     ; 79 	  S1 = LCD_VALUE[LCD_INDEX[2]];
1888  0058 b602          	ld	a,_LCD_INDEX+2
1889  005a 5f            	clrw	x
1890  005b 97            	ld	xl,a
1891  005c d60000        	ld	a,(_LCD_VALUE,x)
1892  005f 6b02          	ld	(OFST-2,sp),a
1893                     ; 80 		S2 = LCD_VALUE[LCD_INDEX[1]];
1895  0061 5f            	clrw	x
1896  0062 b601          	ld	a,_LCD_INDEX+1
1897  0064 97            	ld	xl,a
1898  0065 d60000        	ld	a,(_LCD_VALUE,x)
1899  0068 6b03          	ld	(OFST-1,sp),a
1900                     ; 81 		S3 = LCD_VALUE[LCD_INDEX[0]]; 
1902  006a 5f            	clrw	x
1903  006b b600          	ld	a,_LCD_INDEX
1904  006d 97            	ld	xl,a
1905  006e d60000        	ld	a,(_LCD_VALUE,x)
1906  0071 6b04          	ld	(OFST+0,sp),a
1907                     ; 85     PA_ODR = ((S3 & 0xF0) >> 2);
1909  0073 a4f0          	and	a,#240
1910  0075 44            	srl	a
1911  0076 44            	srl	a
1912  0077 c75000        	ld	_PA_ODR,a
1913                     ; 86 		PB_ODR = (S2 & 0x0F) + ((S1 & 0x0F) << 4);
1915  007a 7b02          	ld	a,(OFST-2,sp)
1916  007c a40f          	and	a,#15
1917  007e 97            	ld	xl,a
1918  007f a610          	ld	a,#16
1919  0081 42            	mul	x,a
1920  0082 9f            	ld	a,xl
1921  0083 6b01          	ld	(OFST-3,sp),a
1922  0085 7b03          	ld	a,(OFST-1,sp)
1923  0087 a40f          	and	a,#15
1924  0089 1b01          	add	a,(OFST-3,sp)
1925  008b c75005        	ld	_PB_ODR,a
1926                     ; 87     PC_ODR = ((S2 & 0xF0) >> 1); 
1928  008e 7b03          	ld	a,(OFST-1,sp)
1929  0090 a4f0          	and	a,#240
1930  0092 44            	srl	a
1931  0093 c7500a        	ld	_PC_ODR,a
1932                     ; 88     PD_ODR = (S3 & 0x0F) + ((S1 & 0xE0) >> 1);
1934  0096 7b02          	ld	a,(OFST-2,sp)
1935  0098 a4e0          	and	a,#224
1936  009a 44            	srl	a
1937  009b 6b01          	ld	(OFST-3,sp),a
1938  009d 7b04          	ld	a,(OFST+0,sp)
1939  009f a40f          	and	a,#15
1940  00a1 1b01          	add	a,(OFST-3,sp)
1941  00a3 c7500f        	ld	_PD_ODR,a
1942                     ; 98   CFG_GCR = 0x01; //disable AL bit, disable SWIM
1944  00a6 35017f60      	mov	_CFG_GCR,#1
1945                     ; 99   PC_CR1 |= 0x04; //enable pull-up
1947  00aa 7214500d      	bset	_PC_CR1,#2
1948                     ; 101   EXTI_SR1 &= 0x04; //clear interrupt flag 
1950  00ae c650a3        	ld	a,_EXTI_SR1
1951  00b1 a404          	and	a,#4
1952  00b3 c750a3        	ld	_EXTI_SR1,a
1953                     ; 102 	return;
1956  00b6 5b04          	addw	sp,#4
1957  00b8 80            	iret	
1980                     ; 106 @far @interrupt void NonHandledInterrupt2 (void)
1980                     ; 107 {
1981                     	switch	.text
1982  00b9               f_NonHandledInterrupt2:
1986                     ; 111 	return;
1989  00b9 80            	iret	
2012                     ; 114 @far @interrupt void NonHandledInterrupt (void)
2012                     ; 115 {
2013                     	switch	.text
2014  00ba               f_NonHandledInterrupt:
2018                     ; 119 	return;
2021  00ba 80            	iret	
2023                     .const:	section	.text
2024  0000               __vectab:
2025  0000 82            	dc.b	130
2027  0001 00            	dc.b	page(__stext)
2028  0002 0000          	dc.w	__stext
2029  0004 82            	dc.b	130
2031  0005 ba            	dc.b	page(f_NonHandledInterrupt)
2032  0006 00ba          	dc.w	f_NonHandledInterrupt
2033  0008 82            	dc.b	130
2035  0009 ba            	dc.b	page(f_NonHandledInterrupt)
2036  000a 00ba          	dc.w	f_NonHandledInterrupt
2037  000c 82            	dc.b	130
2039  000d ba            	dc.b	page(f_NonHandledInterrupt)
2040  000e 00ba          	dc.w	f_NonHandledInterrupt
2041  0010 82            	dc.b	130
2043  0011 ba            	dc.b	page(f_NonHandledInterrupt)
2044  0012 00ba          	dc.w	f_NonHandledInterrupt
2045  0014 82            	dc.b	130
2047  0015 ba            	dc.b	page(f_NonHandledInterrupt)
2048  0016 00ba          	dc.w	f_NonHandledInterrupt
2049  0018 82            	dc.b	130
2051  0019 00            	dc.b	page(f_AWU_Interrupt)
2052  001a 0000          	dc.w	f_AWU_Interrupt
2053  001c 82            	dc.b	130
2055  001d ba            	dc.b	page(f_NonHandledInterrupt)
2056  001e 00ba          	dc.w	f_NonHandledInterrupt
2057  0020 82            	dc.b	130
2059  0021 ba            	dc.b	page(f_NonHandledInterrupt)
2060  0022 00ba          	dc.w	f_NonHandledInterrupt
2061  0024 82            	dc.b	130
2063  0025 ba            	dc.b	page(f_NonHandledInterrupt)
2064  0026 00ba          	dc.w	f_NonHandledInterrupt
2065  0028 82            	dc.b	130
2067  0029 ba            	dc.b	page(f_NonHandledInterrupt)
2068  002a 00ba          	dc.w	f_NonHandledInterrupt
2069  002c 82            	dc.b	130
2071  002d ba            	dc.b	page(f_NonHandledInterrupt)
2072  002e 00ba          	dc.w	f_NonHandledInterrupt
2073  0030 82            	dc.b	130
2075  0031 2c            	dc.b	page(f_Button2_Interrupt)
2076  0032 002c          	dc.w	f_Button2_Interrupt
2077  0034 82            	dc.b	130
2079  0035 ba            	dc.b	page(f_NonHandledInterrupt)
2080  0036 00ba          	dc.w	f_NonHandledInterrupt
2081  0038 82            	dc.b	130
2083  0039 ba            	dc.b	page(f_NonHandledInterrupt)
2084  003a 00ba          	dc.w	f_NonHandledInterrupt
2085  003c 82            	dc.b	130
2087  003d ba            	dc.b	page(f_NonHandledInterrupt)
2088  003e 00ba          	dc.w	f_NonHandledInterrupt
2089  0040 82            	dc.b	130
2091  0041 00            	dc.b	page(f_Button1_Interrupt)
2092  0042 0000          	dc.w	f_Button1_Interrupt
2093  0044 82            	dc.b	130
2095  0045 ba            	dc.b	page(f_NonHandledInterrupt)
2096  0046 00ba          	dc.w	f_NonHandledInterrupt
2097  0048 82            	dc.b	130
2099  0049 ba            	dc.b	page(f_NonHandledInterrupt)
2100  004a 00ba          	dc.w	f_NonHandledInterrupt
2101  004c 82            	dc.b	130
2103  004d ba            	dc.b	page(f_NonHandledInterrupt)
2104  004e 00ba          	dc.w	f_NonHandledInterrupt
2105  0050 82            	dc.b	130
2107  0051 ba            	dc.b	page(f_NonHandledInterrupt)
2108  0052 00ba          	dc.w	f_NonHandledInterrupt
2109  0054 82            	dc.b	130
2111  0055 ba            	dc.b	page(f_NonHandledInterrupt)
2112  0056 00ba          	dc.w	f_NonHandledInterrupt
2113  0058 82            	dc.b	130
2115  0059 ba            	dc.b	page(f_NonHandledInterrupt)
2116  005a 00ba          	dc.w	f_NonHandledInterrupt
2117  005c 82            	dc.b	130
2119  005d ba            	dc.b	page(f_NonHandledInterrupt)
2120  005e 00ba          	dc.w	f_NonHandledInterrupt
2121  0060 82            	dc.b	130
2123  0061 ba            	dc.b	page(f_NonHandledInterrupt)
2124  0062 00ba          	dc.w	f_NonHandledInterrupt
2125  0064 82            	dc.b	130
2127  0065 ba            	dc.b	page(f_NonHandledInterrupt)
2128  0066 00ba          	dc.w	f_NonHandledInterrupt
2129  0068 82            	dc.b	130
2131  0069 ba            	dc.b	page(f_NonHandledInterrupt)
2132  006a 00ba          	dc.w	f_NonHandledInterrupt
2133  006c 82            	dc.b	130
2135  006d ba            	dc.b	page(f_NonHandledInterrupt)
2136  006e 00ba          	dc.w	f_NonHandledInterrupt
2137  0070 82            	dc.b	130
2139  0071 ba            	dc.b	page(f_NonHandledInterrupt)
2140  0072 00ba          	dc.w	f_NonHandledInterrupt
2141  0074 82            	dc.b	130
2143  0075 ba            	dc.b	page(f_NonHandledInterrupt)
2144  0076 00ba          	dc.w	f_NonHandledInterrupt
2145  0078 82            	dc.b	130
2147  0079 ba            	dc.b	page(f_NonHandledInterrupt)
2148  007a 00ba          	dc.w	f_NonHandledInterrupt
2149  007c 82            	dc.b	130
2151  007d ba            	dc.b	page(f_NonHandledInterrupt)
2152  007e 00ba          	dc.w	f_NonHandledInterrupt
2203                     	xdef	__vectab
2204                     	xref	__stext
2205                     	xdef	f_NonHandledInterrupt
2206                     	xdef	f_NonHandledInterrupt2
2207                     	xdef	f_Button2_Interrupt
2208                     	xdef	f_Button1_Interrupt
2209                     	xdef	f_AWU_Interrupt
2210                     	xref.b	_Flags
2211                     	xref	_Left_Button_RAM
2212                     	xref.b	_LCD_INDEX
2213                     	xref	_LCD_VALUE
2214                     	xref.b	c_x
2215                     	xref.b	c_y
2234                     	end
